<cfprocessingdirective suppressWhitespace="yes">
<cfsilent>
<cfprocessingdirective pageEncoding="utf-8" />
<!--- ------------------------------------------
作成日：2014/04/01
作成者：WEING
説明　：社員一括取込結果画面
更新日：
---------------------------------------------->

<!--- 初期変数宣言 --->
<cfset Attributes.DisplayNm	 = '社員一括取込結果画面'>	<!--- 画面名 --->
<cfset sMessage = "">									<!--アップロード成功、失敗メッセージ出力 --->

<!---アップロード情報--->
<cfset sUpdDir		= ExpandPath("temp\upload\")>		<!---ファイルパス--->
<cfset sUpdFileNM	= "">								<!---ファイル名--->

<cfset iItemCount	= 6>								<!--- 出力項目数 --->
<cfset iRowIdx		= 0>								<!--- 出力行数 --->
<cfset iRowErr		= 0>								<!--- エラーフラグ --->
<cfset bErrFlg		= false>							<!--- 全体のエラーフラグ（True:エラー有/False:エラー無） --->

<!--- 入力チェック関連 --->
<cfset aErrSyo	= ArrayNew(1)>							<!--- 詳細エラーメッセージ --->
<cfloop index="i" from="1" to="#iItemCount#">
	<cfset aErrSyo[i]	= "">							<!--- 詳細エラーメッセージ初期化 --->
</cfloop>

<!--- ****** １．ファイルアップロード ****** --->
<!--- アップロードフォルダ作成 --->
<cfif not DirectoryExists(sUpdDir)>
	<cfdirectory action="create" directory="#sUpdDir#">
</cfif>

<!--- 1．アップロード処理 --->
<cftry>
	<!--- サーバー上のディレクトリにファイルをコピー --->
	<cffile action="upload" filefield="form.temp_filename" destination="#sUpdDir#" nameconflict="overwrite" />
	<cfset sUpdFileNM = cffile.clientFile><!--- ファイル名 --->
	<!--- Excelファイル拡張子チェック --->
	<cfif (Right(sUpdFileNM, 4) neq ".xls")>
		<cfset aErrSyo[1]	= "アップロードされたファイルは.xls形式ではありません。">
		<cfset iRowErr		= 1>
		<cfset bErrFlg		= true>
	</cfif>
	<cfif bErrFlg eq false>
		<!--- Excelデータ読み取り --->
		<cfspreadsheet action="read" src="#sUpdDir##sUpdFileNM#" query="qData" sheet="1">
	</cfif>

	<!--- アップロードしたファイルを削除する --->
	<cffile action="delete" file="#sUpdDir##sUpdFileNM#">

	<!--- UPLODAがNGの場合はエラーメッセージ --->
	<cfcatch type = "any">
		<cfset bErrFlg = true>
	</cfcatch>
</cftry>

<!--- ２．トランザクション処理開始 --->
<cftransaction action="begin">
	<cftry>
		<!--- 社員マスタに登録 --->
		<cfif bErrFlg eq false>
			<cfset iNullCnt = 0>
			<!--- 項目数チェック --->
			<cfif ListLen(qData.ColumnList) neq #iItemCount#>
				<cfset iRowErr = 1>
				<cfset aErrSyo[1] = "項目数が不一致です。">
			<cfelse>
				<!---入力チェック(3行目～)--->
				<cfloop query="qData" startRow="3">
					<cfset iRowIdx = qData.CurrentRow>
					<cfset iNullCnt = iNullCnt + 1>
					<!--- 社員番号チェック(必須、桁数、半角英数字) --->
					<cfif qData['col_1'][iRowIdx] eq '' or (len(qData['col_1'][iRowIdx]) gt 8 or Refind("^[A-Za-z0-9]+$",qData['col_1'][iRowIdx]) neq 1)>
						<cfset aErrSyo[1] = "社員番号を半角英数8桁以内で入力してください。">
						<cfset iRowErr = 1>
					</cfif>
					<!--- 名前チェック(桁数) --->
					<cfif len(qData['col_2'][iRowIdx]) gt 50>
						<cfset aErrSyo[2] = "名前は50文字以内に入力してください。">
						<cfset iRowErr = 1>
					</cfif>
					<!--- ふりがなチェック(桁数、全角カナまたは全角ひらがな) --->
					<cfset tmpVal = replace(qData['col_3'][iRowIdx],"　","",'all')>
					<cfset tmpVal = replace(tmpVal," ","",'all')>
					<cfset tmpVal = trim(tmpVal)>
					<cfif len(qData['col_3'][iRowIdx]) gt 50 or (qData['col_3'][iRowIdx] neq "" and Refind("^[ァ-ヶぁ-ん]+$",tmpVal) neq 1)>
						<cfset aErrSyo[3] = "ふりがなは全角カナまたは全角ひらがなで入力してください。">
						<cfset iRowErr = 1>
					</cfif>
					<!--- 性別(桁数、入力文言) --->
					<cfif len(qData['col_4'][iRowIdx]) gt 5>
						<cfset aErrSyo[4] = "性別は5文字以内に入力してください。">
						<cfset iRowErr = 1>
					</cfif>
					<!--- 年齢(桁数、半角数値) --->
					<cfif len(qData['col_5'][iRowIdx]) gt 3 or (qData['col_5'][iRowIdx] neq "" and Refind("^[0-9]+$",qData['col_5'][iRowIdx]) neq 1)>
						<cfset aErrSyo[5] = "年齢は半角数値3文字以内に入力してください。">
						<cfset iRowErr = 1>
					</cfif>
					<!--- 生年月日(日付) --->
					<cfif qData['col_6'][iRowIdx] neq "">
						<cfif not IsDate(qData['col_6'][iRowIdx])>
							<cfset aErrSyo[6] = "生年月日は正しい日付(yyyy/mm/dd形式)を入力してください。">
							<cfset iRowErr = 1>
						</cfif>
					</cfif>
				</cfloop>
			</cfif>

			<!--- エラーがない場合は存在チェック --->
			<cfif iRowErr eq 0>
				<cfloop query="qData" startRow="3">
					<cfset iRowIdx = qData.CurrentRow>
					<cfset iNullCnt = iNullCnt + 1>
					<cfif qData['col_1'][iRowIdx] neq "">
						<cfquery name="qSelUpdTarget" datasource="#application.dsname#">
							SELECT	*
							FROM	M_USER
							WHERE	USER_ID = <cfqueryparam value="#qData['col_1'][iRowIdx]#" cfsqltype="CF_SQL_VARCHAR" maxlength="8">
						</cfquery>
						<!--- 同じ社員番号が存在する場合、更新処理を行う --->
						<cfif qSelUpdTarget.RecordCount neq 0>
							<cfloop query="qSelUpdTarget">
								<!--- 社員マスタを更新 --->
								<cfquery name="qUpdData" datasource="#Application.dsname#">
									UPDATE	M_USER
									SET		USER_NM		=<cfqueryparam cfsqltype="cf_sql_varchar" value="#qData['col_2'][iRowIdx]#">
											,USERKANA_NM=<cfqueryparam cfsqltype="cf_sql_varchar" value="#qData['col_3'][iRowIdx]#">
											,SEX		=<cfqueryparam cfsqltype="cf_sql_varchar" value="#qData['col_4'][iRowIdx]#">
											,AGE		=<cfqueryparam cfsqltype="cf_sql_varchar" value="#qData['col_5'][iRowIdx]#">
											,BIRTHDAY	=<cfqueryparam cfsqltype="cf_sql_varchar" value="#qData['col_6'][iRowIdx]#">
									WHERE	USER_ID 	=<cfqueryparam cfsqltype="cf_sql_varchar" value="#qSelUpdTarget.USER_ID#">
								</cfquery>
							</cfloop>
						<cfelse>
							<!--- 同じ社員番号ではない場合、登録処理を行う --->
							<cfquery name="qInsData" datasource="#Application.dsname#">
								INSERT INTO M_USER (
									USER_ID
									,USER_NM
									,USERKANA_NM
									,SEX
									,AGE
									,BIRTHDAY
								) VALUES (
									 <cfqueryparam value="#qData['col_1'][iRowIdx]#" cfsqltype="cf_sql_varchar" maxlength="8">
									,<cfqueryparam value="#qData['col_2'][iRowIdx]#" cfsqltype="cf_sql_varchar" maxlength="50">
									,<cfqueryparam value="#qData['col_3'][iRowIdx]#" cfsqltype="cf_sql_varchar" maxlength="50">
									,<cfqueryparam value="#qData['col_4'][iRowIdx]#" cfsqltype="cf_sql_varchar" maxlength="5">
									,<cfqueryparam value="#qData['col_5'][iRowIdx]#" cfsqltype="cf_sql_varchar" maxlength="3">
									,<cfqueryparam value="#qData['col_6'][iRowIdx]#" cfsqltype="cf_sql_varchar" maxlength="10">
								)
							</cfquery>
						</cfif>
					</cfif>
				</cfloop>
			</cfif>
		</cfif>

		<!--- トランザクション処理コミット --->
		<cftransaction action="commit" />

		<!--- エラー発生時 --->
		<cfcatch type = "any">
			<cfset bErrFlg = true>
			<!--- ロールバック --->
			<cftransaction action="rollback" />
		</cfcatch>
	</cftry>
</cftransaction>

<!--- エラーメッセージ設定 --->
<cfif bErrFlg eq true or iRowErr eq 1>
	<cfset sMessage = "社員データ一括更新に失敗しました。">
	<cfset sColor	= "color:##FF0000; background-color:##FFC0CB;">
<cfelse>
	<cfset sMessage = "社員データ一括更新に成功しました。">
	<cfset sColor 	= "color:##0000FF; background-color:##FFFACD;">
</cfif>
</cfsilent>

<!--- ****** ２．アップロード結果を表示 ****** --->
<cfoutput>
<html>
	<head>
		<!--- ヘッダをインクルード --->
		<cfinclude template="./common/header.cfm">
		<link rel="stylesheet" href="./common/style.css" type="text/css">
	</head>
	<body>
		<div align="center">
			<!--- 内容 --->
			<div style="width:800px;">
				<div class="divBase">
					<h3>社員データ登録結果</h3>
				</div>

				<table border="0" cellpadding="0" cellspacing="0">
					<tr>
						<td>
							<div class="divBase">
								<table class="tableBase" cellspacing="0" cellpadding="5">
									<tr>
										<td class="tdBase2" style="width:800px; #sColor#" align="center">#sMessage#</td>
										<td class="tdBase2" style="#sColor#" align="center">
											<input type="button" class="btn" value="戻る" onClick="history.back();">
										</td>
									</tr>
								</table>
							</div>
						</td>
					</tr>
					<tr><td height="20"></td></tr>

					<!--- エラー内容表示 --->
					<cfif iRowErr eq 1>
						<tr>
							<td>
								<table class="tableBase" cellspacing="0" cellpadding="5">
									<tr>
										<th class="thBase" nowrap width="30px">No.</th>
										<th class="thBase">エラー内容</th>
									</tr>
									<cfset iNo = 0>
									<cfloop index="idx" from="1" to="#ArrayLen(aErrSyo)#">
										<cfif aErrSyo[idx] neq "">
											<cfset iNo = iNo + 1>
											<tr>
												<td class="tdBase1" align="right">#iNo#</td>
												<td class="tdBase1">#HtmlEditFormat(aErrSyo[idx])#</td>
											</tr>
										</cfif>
									</cfloop>
								</table>
							</td>
						</tr>
						<tr><td height="20"></td></tr>
					</cfif>
				</table>
			</div>

			<!--- フッダをインクルード --->
			<cfinclude template="./common/footer.cfm">
		</div>
	</body>
</html>
</cfoutput>

</cfprocessingdirective>
